<?php

/*
   Randomize a given table of text strings such as names or other items.
   One item string per line.

   Author  : Jay Tanner
   License : Public Domain
*/

   ob_start();

// Define script path and filename.
   $_AUTHOR_          = 'Jay Tanner';
   $_PROGRAM_VERSION_ = '';
   $at                = "&#97;&#116;";
   $UTC               = "&#85;&#84;&#67";
   $_SCRIPT_PATH_     = Filter_Input(INPUT_SERVER, 'SCRIPT_FILENAME');
   $_RUN_             = Filter_Input(INPUT_POST, 'SCRIPT_NAME');

// Define internal document page title, HTML page heading text and revision date
   $_INTERNAL_TITLE_  = "Shuffle Text Lines";
   $_INTERFACE_TITLE_ = "<b style='font-size:175%; font-weight:normal;'>Randomize or Shuffle Text Lines or List Items</b><br><span style='font-size:12px;'>PHP Program by Jay Tanner</span>";
   $_REVISION_DATE_   = $_PROGRAM_VERSION_ .'Revised: '. GMDate("l, F d, Y $at h:i:s A   $UTC", FileMTime($_SCRIPT_PATH_));

// Define main TextArea text, background
// colors and HTML table row span.
   $TxColor = 'black';
   $BgColor = 'white';
   $ColSpan = 7;


   $TxTableStr = trim(Filter_Input(INPUT_POST, 'TextArea1'));

// Define default items table to use
// when the text input box is empty.
        if ($TxTableStr == '')
  {
  $TxTableStr =
"
The Kitchen Sink
Abraham Lincoln
The Hunchback of Notre Dame
Saturn
The Easter Bunny
My Neighbor's House
Captain James T. Kirk
The Tooth Fairy
Albert Einstein
Mother Goose
Ebenezer Scrooge
";
  }


// ===================================================
// Begin computations here if no error detected above.

   $RandomizedItems = Randomize_Text_Lines($TxTableStr);
//   $RandomizedItems = Format_N_Cols_($RandomizedItems, 1);

   $TextArea1Text = $RandomizedItems;


// ===================================================





// Determine the number of text rows to use in the output TextArea.
//   $NumCharacters = StrLen($TextArea1Text);
//   $TextArea1Rows = ($NumCharacters < 180)? 10 : 5 + 2*floor($NumCharacters / 135);
   $TextArea1Rows = 2 + substr_count($TextArea1Text, "\n");



print <<< _HTML

<!DOCTYPE='HTML'>

<html lang='en'>

<head>

<title>Randomize or Shuffle List of Items</title>

<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta name="description" content="This PHP program randomly shuffles a list of items.">
<meta name="keywords" content="shuffle list,randomize list,random,random list,PHPScienceLabs.com">
<meta name="author" content="Jay Tanner - PHPScienceLabs.com">
<meta http-equiv="pragma"  content="no-cache">
<meta http-equiv="expires" content="-1">
<meta name="robots"    content="index,follow">
<meta name="googlebot" content="index,follow">
<link rel="canonical" href="https://www.phpsciencelabs.com/randomize-or-shuffle-list-items/">

<style type='text/css'>
 BODY
{color:silver; background-color:black;  font-family:Verdana; font-size:100%}

 TABLE
{font-size:12px; border: 1px solid black;}

 TD
{color:black; background-color:white; line-height:200%; font-size:12px;
padding:6px; text-align:center;}

 DIV
{
 color:black; background-color:white; font-family:Verdana; font-size:110%;
 text-align:justify; padding:4px;
}

 PRE
{color:black; background-color:white; font-family:monospace; font-size:150%;
font-weight:bold; text-align:left; padding:4px;}

 CODE
{font-family:monospace; font-size:150%; font-weight:normal;}

 TEXTAREA
{
 color:black; background:white; font-family:Consolas,Inconsolata,monospace; font-size:155%;
 font-weight:bold; border-radius: 8px; border:1px solid black; padding:4px; letter-spacing:1px;
 white-space:pre;
}


 INPUT[type="text"]::-ms-clear {width:0; height:0;}

 INPUT[type='text']
{
 color:black; background:white; font-size:150%; font-family:monospace;
 font-weight:bold; text-align:center; box-shadow:2px 2px 3px #666666;
 border:2px solid black;
}

 INPUT[type='text']:focus
{
 background:white; box-shadow:2px 2px 3px #666666; font-family:monospace;
 font-size:150%; border:2px solid red; text-align:center; font-weight:bold;
}

 INPUT[type='submit']
{font-weight:bold; border-radius:4px;}

 INPUT[type='submit']:hover
{box-shadow:2px 2px 5px #555555; font-weight:bold;}

 HR {background:black; height:2px; border:0px;}

 A:link
{
 font-size:100%; background:transparent; color:blue; font-family:Verdana;
 font-weight:bold; text-decoration:none; line-height:175%; padding:3px;
 border:1px solid transparent;
}

 A:visited {font-size:100%; background:transparent; color:blue;}

 A:hover
{
 font-size:100%; background:yellow; color:black; border:1px solid black;
 box-shadow:1px 1px 3px #222222;
}

 A:active  {font-size:100%; background:yellow; color:black;}

::selection      {background-color:yellow; color:black;}
::-moz-selection {background-color:yellow; color:black;}
</style>

</head>

<body>

<form name='form1' method='post' action="$_RUN_">

<table align='left' width='800' border='0' cellspacing='1' cellpadding='3'>

<tr><td colspan="$ColSpan" style='color:white; background-color:#000066; border:2px solid white; border-radius:8px 8px 0px 0px;'><b>$_INTERFACE_TITLE_</b></td></tr>




<tr><td colspan="$ColSpan" style='background-color:black;'>
<span style='color:white;'>Replace the initial default items list with your own list of items to randomize.<br>An empty list input reloads the initial default demo listing.<br>Each Line is a separate string or item in the table and can contain inner spaces.<br></span>
<br>
<input name='RandomizeButton' type='submit' value='SHUFFLE  LIST'>
</td></tr>



<tr>
<td colspan="$ColSpan" style='background-color:black;'>
<span style='color:white;'>Double-Click Within Table to Select ALL Text</span>
<textarea name='TextArea1' color:$TxColor; background:$BgColor; padding:6px; border:2px solid white;' cols="81" rows="$TextArea1Rows" OnDblClick='this.select();' OnMouseUp='return true;' title=' Double-Click to Select ALL Text '>
$TextArea1Text
</textarea></td>
</tr>




<tr><td colspan="$ColSpan" style='color:gray; background:black;'>$_REVISION_DATE_</td></tr>


</table>
</form>

</body>




_HTML;





/*
   ==========================================================================
   This function shuffles a ctring of any characters into a new randomized
   sequence with the option of also including spaces as string characters.

   The argument string ('ABCDEFGHIJKLMNOPQRSTUVWXYZ')
   would return something like: 'UAJYOXWSRKTIBPHMFGQLZNCEDV'
   or another randomized sequence of the same characters.

   SpacescountFlag = Flag to indicate if or not spaces should be counted
                     as a character in the string or if they should be
                     ignored and have no influence in the shuffle.
                     FALSE = All spaces removed from the shuffled string.
                           = Default.
                     TRUE  = Spaces count as part of the shuffled string.

   NO DEPENDENCIES
   ==========================================================================
*/

   function Randomize_Items ($ItemsString, $SpacescountFlag=FALSE)
{
   // Read items string argument convert
   // defined delimiters into spaces.
   // Delimiters are spaces, commas, semicolons or vertical bar characters |
      $w = trim($ItemsString);
      $w = Str_Replace(',', ' ', $w);
      $w = Str_Replace(';', ' ', $w);
      $w = Str_Replace('|', ' ', $w);

   // Normalize spacing within the string, removing any redundant
   // white space to ensure only single spaces between the items.
      $w = PReg_Replace("/\s+/", " ", trim($w));

   // If no items, then return empty string result.
      if ($w == '') {return $w;}

   // Split data string into array elements and shuffle them.
      $wArray = PReg_Split("[ ]", $w);  shuffle($wArray);

   // Construct randomized items output string.
      $wcount = count($wArray);
      $wOut = '';
      for ($i=0;   $i < $wcount;   $i++) {$wOut .= trim($wArray[$i]) . " ";}

   // Done.
   return trim($wOut);
}




/*
   ===========================================================================
   This function formats a space-delimited text data string into an N-column
   data table. (Intended for use with a fixed-width font).

   The text table argument may already be a formatted table or a single
   space-delimited data elements string.

   ARGUMENTS:
   TextDataTable = The table of data as a string of delimited elements.
                   The elements may be alpha and/or numeric values.

   Columns = Number of columns into which to arrange the data table.

   DEPENDENCY: Get_Max_Str_Len()
   ===========================================================================
*/

   function Format_N_Cols_ ($TextDataTable, $Columns=1)
{
// Read text data table string.  Could be a single item.
   $T = trim($TextDataTable);

// Convert any alternate delimiters into spaces
// amd then delete any redundant white space.
   $T = Str_Replace(',',  ' ', $T);
   $T = Str_Replace(';',  ' ', $T);
   $T = Str_Replace('|',  ' ', $T);
   $T = Str_Replace("\n", ' ', $T);
   $T = PReg_Replace("/\s+/", ' ', trim($T));

// Read number of columns argument.
   $C = abs(IntVal(trim($Columns)));

// If (columns == 0), then return data as one long
// string of single-space-delimited elements.
   if ($C == 0)  {return $T;}

// Forbid columns < 0 argument and change to 1.
   if ($C < 1) {$C = 1;}

// First, convert data table into single column format.
   $T = Str_Replace(' ', "\n", $T);

// Convert to array.
   $TArray = explode("\n", $T);
   $Tcount = count($TArray);

// Get length of longest data element.
   $maxLen = Get_Max_Str_Len ($T);
   $padding = Str_Repeat(' ', $maxLen + 2);

// Now convert single column into a (C-column) table.
   $wTable = '';

   for ($i=0;   $i < $Tcount;   $i++)
{
   $t = trim($TArray[$i]);
   $t = substr($t.$padding, 0, $maxLen+2);
   $wTable .= "$t";
   if (($i+1) % $C == 0) {$wTable = $wTable . "\n";}
}
   return trim($wTable);

} // end of  Format_N_Cols_ (...)




/*
   ===========================================================================
   This function returns the length of the longest data element
   in a string of data elements separated my spaces.

   The argument: '58.739 58.852112 61.906 58.70127 60.14961'
   would return 9 because that is the length of the longest
   data element '58.852112' within the string, consisting of
   9 characters, including the decimal point, longer than any
   of the other delimited elements within the string.

   NO DEPENDENCIES
   ===========================================================================
*/
   function Get_Max_Str_Len ($TextString)
{
   $X = trim($TextString);

   $X = Str_Replace(',',  ' ', $X);
   $X = Str_Replace(';',  ' ', $X);
   $X = Str_Replace('|',  ' ', $X);
   $X = Str_Replace("\n", ' ', $X);

   $X = PReg_Replace("/\s+/", " ", trim($X));

// At this point, all data points are separated
// by a single space between elements in the
// form of a single long string (X).

// Store (X) data elements in work array
// and count the data elements.
   $wArray = PReg_Split("[ ]", $X);
   $wcount = count($wArray);

   $maxLen = 0;

   for($i=0;   $i < $wcount;   $i++)
      {
       $CurrLen = StrLen(trim($wArray[$i]));
       if ($CurrLen > $maxLen) {$maxLen = $CurrLen;}
      }

   return $maxLen;
}





/*
   ---------------------------------------------------------------------------
   This function randomizes or shuffles a given table of text strings or
   lines of any given names or items in a listing.

   An empty argument returns an empty string.

   NO DEPENDENCIES
   ---------------------------------------------------------------------------
*/

   function Randomize_Text_Lines ($TextLinesStr)
{
// Read text lines string, convert into array of text lines
// and then count the text strings (lines or items).
   $TxLines = trim($TextLinesStr);   if ($TxLines == '') {return '';}
   $TxArray = PReg_Split("[\n]", $TxLines);
   $TxCount = count($TxArray);

// Randomly shuffle the array items twice.
   shuffle($TxArray);  shuffle($TxArray);

// Convert array back into a randomised table of text lines.
   $RandTxLines = trim(implode("\n", $TxArray));

   return $RandTxLines;
}


?>


